part of viltage;

class State {
  List<CharNode> nodes = new List<CharNode>();
  Entity entity;
  
  State(this.entity) { }
  
  CharNode createCharNode(int x, int y, String text) {
    CharNode cn;
    cn = new CharNode(x, y, text, entity);
    nodes.add(cn);
    return cn;
  }
  
  List<CharNode> createCharNodeLine(int x, int y, String text, [bool horizontal= true]) {
    List<CharNode> charNodes = new List<CharNode>();
    for(int i = 0; i < text.length; i++) {
      if(horizontal) charNodes.add(createCharNode(x + i, y, text[i]));
      else charNodes.add(createCharNode(x, y + i, text[i]));
    }
    return charNodes;
  }
  
  List<List<CharNode>> createCharNodeRect(int x, int y, List<String> text) {
    List<List<CharNode>> charNodes = new List<List<CharNode>>();
    for(int i = 0; i < text.length; i++) {
      charNodes.add(createCharNodeLine(x, y+i, text[i], true));
    }
    return charNodes;
  }
}