part of viltage;

class VilTAGEConfig {
  CanvasElement canvas;
  int get width => _width ;               int _width = 80;
  int get height => _height;              int _height = 60;
  int get boxWidth => _boxWidth;          int _boxWidth;
  int get boxHeight => _boxHeight;        int _boxHeight;
  int fontSize = 15;
  int fontColor = 0x000000;
  String fontName = "Monospace";
  
  VilTAGEConfig(this.canvas) {
    canvas.width = 800;
    canvas.height = 600;
    _calc();
  }
  
  set width(int width) {
    _width = width;
    _calc();
  }

  set height(int height) {
    _height = height;
    _calc();
  }
  
  set boxWidth(int boxWidth) {
    _boxWidth = boxWidth;
    _calcByBox();
  }
  
  set boxHeight(int boxHeight) {
    _boxHeight = boxHeight;
    _calcByBox();
  }
  
  _calc() {
    _boxWidth = canvas.width~/width;
    _boxHeight = canvas.height~/height;
  }
  
  _calcByBox() {
    canvas.width = _boxWidth * width;
    canvas.height = _boxHeight * height;
  }
}